=== debian/changelog ===
purrdata-faustgen2 (2.2.0+git514+abb1c7d-1) bionic; urgency=low

  * Build from latest upstream source.

 -- Albert Graef <aggraef@gmail.com>  Wed, 25 Jan 2023 23:59:03 +0100

purrdata-faustgen2 (2.0.2-1) bionic; urgency=low

  * Build from latest upstream source.

 -- Albert Graef <aggraef@gmail.com>  Wed, 04 Nov 2020 18:34:35 +0100
