## purrdata-faustgen2 2.2.0%2Bgit520%2Bec2f802

=== CMakeLists.txt ===
--- 
+++ 
@@ -3,6 +3,11 @@
 set(CMAKE_SUPPRESS_REGENERATION true)
 set(CMAKE_MACOSX_RPATH Off)
 set(CMAKE_OSX_DEPLOYMENT_TARGET 10.9)
+
+## Set this to ON to compile the Pure Data external with double precision support.
+## This implies using it with Pure Data compiled with the flag PD_FLOATSIZE=64", which isn't the default.
+set(PD_FLOATSIZE64 "OFF"  CACHE BOOL  "Compile externals targeting Pd double precision (compiled with PD_FLOATSIZE=64)")
+message(STATUS "Using PD_FLOATSIZE=64: ${PD_FLOATSIZE64}")
 
 include(pd.build/pd.cmake)
