=== debian/changelog ===
purrdata-faustgen2 (2.2.0+git520+ec2f802-1) bionic; urgency=low

  * Build from latest upstream source.

 -- Albert Graef <aggraef@gmail.com>  Sun, 21 Jul 2024 20:02:49 +0200
