=== debian/control ===
--- 
+++ 
@@ -2,7 +2,7 @@
 Section: sound
 Priority: extra
 Maintainer: Albert Graef <aggraef@gmail.com>
-Build-Depends: debhelper (>= 7.0.50~), dh-python, llvm-14-dev | llvm-dev, cmake
+Build-Depends: debhelper (>= 7.0.50~), dh-python, llvm-15-dev | llvm-14-dev | llvm-13-dev | llvm-dev, cmake
 Standards-Version: 3.9.5
 Homepage: https://github.com/agraef/pd-faustgen
